package cn.test.binaryTree;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;

import org.junit.Test;

/**
 * ࣨõݹķ
 * 
 * @param <T>
 */
class BinaryTree<T> {
	/**
	 * ڵ
	 */
	class Node<T> {
		private T t;
		Node leftNode;
		Node rightNode;

		Node(T t) {
			this.t = t;
			this.leftNode = null;
			this.rightNode = null;
		}

		public T getElement() {
			return t;
		}
	}

	private Node rootNode; // ڵ
	private Comparator comparator;// Ƚ

	public BinaryTree() {
		this.comparator = null;
	}

	// бȽĹ캯
	public BinaryTree(Comparator comparator) {
		this.comparator = comparator;
	}

	// ڵ㣬һڵΪڵ
	public void insert(T t) {
		// δȽûбȽϷʱ׳쳣
		if (comparator == null && !(t instanceof Comparable)) {
			throw new RuntimeException("ûдȽ"
					+ t.getClass().getSimpleName() + "಻Comparable");
		}
		if (t == null) {
			return;
		}
		rootNode = insertFun(rootNode, t);
	}

	/*
	 * ()õݹķڵ㣬ĶʱComparableʱøöԴȽ ʹôComparatorȽȽ
	 * ڵĹ򣺵ĽڵСڵڱȽϵĽڵʱӽڵλòڵ㣬ӽڵλûнڵʱڵ㣬ӽڵλнڵ㣬
	 * ӽڵȽϡĽڵڱȽϵĽڵʱӽڵλòڵ㣬ӽڵλûнڵʱڵ㣬ӽڵλнڵ㣬 ӽڵȽϡ
	 */
	private Node insertFun(Node node, T t) {
		System.out.println(t);
		if (node == null) {
			node = new Node(t);
		} else {
			if (t instanceof Comparable && comparator==null) {
				if (((Comparable) t).compareTo(node.getElement()) <= 0) {
					node.leftNode = insertFun(node.leftNode, t);
				} else {
					node.rightNode = insertFun(node.rightNode, t);
				}
			} else {
				if (comparator.compare(t, node.getElement()) <= 0) {
					node.leftNode = insertFun(node.leftNode, t);
				} else {
					node.rightNode = insertFun(node.rightNode, t);
				}
			}
		}
		return node;
	}

	// ȡĶList
	public List getOrderedElements(List list) {
		// System.out.println(rootNode.leftNode.getElement());
		// return null;
		fillList(rootNode, list); // Ķ봫list
		return list;
	}

	/*
	 * ˼·ڵڵʱlistڵ㣨С ӽڵ<ǰڵ<ӽڵ㣩
	 * ҹȲ鿴ڵ㣬ڵӽڵʱӽڵ㣬ӽڵ޵ڵڵʱlistڵ㣬
	 * ٲ鿴ӽڵ㣬ڵӽڵʱӽڵ
	 */
	private void fillList(Node node, List list) {
		if (node == null)
			return;
		//Ȳ߽ڵ
		if (node.leftNode != null) {
			fillList(node.leftNode, list);
		}
		//뵱ǰڵ
		list.add(node.getElement());
		//ٲ߽ڵ
		if (node.rightNode != null) {
			fillList(node.rightNode, list);
		}

	}
}


/**
 * 
 * @author yqj
 *
 */
public class TestClass {
	// ԶComparatorĶ
	@Test
	public void test1() {
		String[] strs = new String[] { "ab", "bc", "ada", "odgae", "dezdf" };
		BinaryTree<String> bt = new BinaryTree<String>(
				new Comparator<String>() {
					// ͨȱȽַȣٱȽĸѭȽ
					@Override
					public int compare(String o1, String o2) {
						return o1.length() != o2.length() ? o2.length()
								- o1.length() : o2.compareTo(o1);
					}
				});
		for (String str : strs) {
			bt.insert(str);
		}
		List<String> list = bt.getOrderedElements(new ArrayList<String>());
		System.out.println(list);
	}
	//ʹStringԴcomparaToȽϣĸ˳
	@Test
	public void test2() {
		String[] strs = new String[] { "ab", "bc", "ada", "odgae", "dezdf" };
		BinaryTree<String> bt = new BinaryTree<String>();
		for (String str : strs) {
			bt.insert(str);
		}
		List<String> list = bt.getOrderedElements(new ArrayList<String>());
		System.out.println(list);
	}
}
